//
//  ViewController.m
//  LocateMe
//
//  Created by Tobias Feigl on 02.06.13.
//  Copyright (c) 2013 Tobias Feigl. All rights reserved.
//

#import "ViewController.h"

@interface ViewController ()

@end

@implementation ViewController
@synthesize locationManager = _locationManager;
@synthesize tableView = _tableView;

- (void)viewDidLoad
{
    latOld = 0;
    lonOld = 0;
    tableView = [[UITableView alloc]init];
    //self.tableView.delegate = self;
    //self.tableView.dataSource = self;
    
    latArray = [[NSMutableArray alloc]init];
    lonArray = [[NSMutableArray alloc]init];
    
    xArray = [[NSMutableArray alloc]init];
    yArray = [[NSMutableArray alloc]init];
    
    self.locationManager = [[CLLocationManager alloc] init];
    self.locationManager.delegate = self;
    self.locationManager.desiredAccuracy = kCLLocationAccuracyBestForNavigation;
    [self.locationManager startUpdatingLocation];
    
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

#define EARTH_RADIUS 6371

-(CGPoint)convertCLLocationToCoordinates:(CGPoint)latLong
{
    CGFloat x = EARTH_RADIUS * cos(latLong.x) * cos(latLong.y);
    CGFloat y = EARTH_RADIUS * cos(latLong.x) * sin(latLong.y);
    
    return CGPointMake(x, y);
}

-(void)locationManager:(CLLocationManager *)manager didUpdateLocations:(NSArray *)locations{
    CLLocation *currentLocation = [locations lastObject];

    NSString *lat = [NSString stringWithFormat:@"%f", currentLocation.coordinate.latitude];
    NSString *lon = [NSString stringWithFormat:@"%f", currentLocation.coordinate.longitude];
    
    //NSString* locationString = [NSString stringWithFormat:@"%@, %@", lat, lon];
    
    CGPoint newPoint;
    newPoint.x = currentLocation.coordinate.latitude;
    newPoint.y = currentLocation.coordinate.longitude;
    //NSLog(@"Coordinates X: %f", [self convertCLLocationToCoordinates:newPoint].x);
    //NSLog(@"Coordinates Y: %f", [self convertCLLocationToCoordinates:newPoint].y);
    
    NSString *x = [NSString stringWithFormat:@"%f", [self convertCLLocationToCoordinates:newPoint].x];
    NSString *y = [NSString stringWithFormat:@"%f", [self convertCLLocationToCoordinates:newPoint].y];
    
    if(latOld != currentLocation.coordinate.latitude){
        [xArray addObject: x];
        [yArray addObject: y];
        [latArray addObject: lat];
        [lonArray addObject: lon];
    
        //NSLog(@"Lat: %@", latArray);
        //NSLog(@"Lon: %@", lonArray);
    
        //[latArray addObject: [NSNumber numberWithDouble: currentLocation.coordinate.latitude]];
        //[latArray addObject: [NSNumber numberWithDouble: currentLocation.coordinate.longitude]];
    
        //[locationManager stopUpdatingLocation];

        latOld = currentLocation.coordinate.latitude;
        [_tableView reloadData];
    }
}

- (void)locationManager:(CLLocationManager *)manager didFailWithError:(NSError *)error
{
	NSLog(@"Error: %@", [error description]);
}

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    if(latArray.count == 0)
        return 1;
    else{
        NSLog(@"Entries: %i", [latArray count]);
        return [latArray count];
    }
}



- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    static NSString *CellIdentifier = @"Cell";
    
    UITableViewCell *cell = [_tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:CellIdentifier];
    }
    
    NSString* coordinateString;
    NSString* locationString;
    if(latArray.count == 0){
        coordinateString = @"No Coordinate Data";
        locationString = @"No Location Data";
    }else{
        locationString = [NSString stringWithFormat:@"Lat: %@, Lon: %@", [latArray objectAtIndex:indexPath.row], [lonArray objectAtIndex:indexPath.row]];
        
        coordinateString = [NSString stringWithFormat:@"X: %@, Y: %@", [xArray objectAtIndex:indexPath.row], [yArray objectAtIndex:indexPath.row]];
    }
    cell.textLabel.text = locationString;
    cell.detailTextLabel.text = coordinateString;
    
    NSIndexPath* path = [NSIndexPath indexPathForRow:latArray.count-1 inSection:0];
    [_tableView scrollToRowAtIndexPath:path atScrollPosition:UITableViewScrollPositionBottom animated:YES];
    
    return cell;
}

@end
